(* Control-/Status word *)
FUNCTION_BLOCK FB_SikoAp20CswTxt
	////////////////////////////////////////////////////////////////////////////////////
	// Name: FB_SikoAp20CswTxt
	////////////////////////////////////////////////////////////////////////////////////
	// Version history
	////////////////////////////////////////////////////////////////////////////////////
	// Date        | Vers. 		| created               | Author          | Remark
	// dd.mm.yyyy  |       		| with                  |                 | 
	// ---------------------------------------------------------------------------------
	// 07.02.2019  | 0.01.00	| AS V4.3.3.196		    | SIKO GmbH / ch  | alpha
	// 21.05.2019  | 1.00.00	| AS V4.3.3.196		    | SIKO GmbH / ch  | first release
	////////////////////////////////////////////////////////////////////////////////////
	
	////////////////////////////////////////////////////////////////////////////////////
	// status word
	//
	// bs00: Reserved
	// bs01: Reserved
	bs02_DisplayDataState := DC_Com.bs02;
	bs03_TargetValueAck := DC_Com.bs03;
	// bs04: Reserved
	bs05_DisplayDataAck := DC_Com.bs05;
	// bs06: Reserved
	bs07_GeneralError := DC_Com.bs07;
	bs08_DisplayDataType := DC_Com.bs08;
	bs09_TargetValueType := DC_Com.bs09;
	bs10_TargetValueState := DC_Com.bs10;
	bs11_BatteryState := DC_Com.bs11;
	bs12_SensorError := DC_Com.bs12;
	bs13_KeyConfiguration := DC_Com.bs13;
	bs14_KeyCalibration := DC_Com.bs14;
	bs15_KeyIncremental := DC_Com.bs15;
	
	////////////////////////////////////////////////////////////////////////////////////
	// control word
	//
	DC_Com.bc00 := 0; // Reserved, ever 0
	DC_Com.bc01 := 0; // Reserved, ever 0
	DC_Com.bc02 := bc02_DisplayDataActive;
	DC_Com.bc03 := bc03_DisplayRange;
	DC_Com.bc04 := 0; // Reserved, ever 0
	DC_Com.bc05 := bc05_ErrorAck;
	DC_Com.bc06 := bc06_TargetValueAckMode;
	DC_Com.bc07 := bc07_TargetValueTypeSelect;
	DC_Com.bc08 := bc08_DisplayDataTypeSelect;
	DC_Com.bc09 := bc09_TargetValueActive;
	DC_Com.bc10 := bc10_DisplayDataAckMode;
	DC_Com.bc11 := bc11_Led1Green;
	DC_Com.bc12 := bc12_Led1Red;
	DC_Com.bc13 := bc13_Led2Green;
	DC_Com.bc14 := bc14_Led2Red;
	DC_Com.bc15 := bc15_LedBlinking;
END_FUNCTION_BLOCK
