(********************************************************************
 * COPYRIGHT -- Bernecker + Rainer
 ********************************************************************
 * Library: SIKO_AP20
 * File: SIKO_AP20.fun
 * Author: Christian Hoffmann
 * Created: February 06, 2019
 ********************************************************************
 * Functions and function blocks of library SIKO_AP20
 ********************************************************************)

FUNCTION_BLOCK FB_SikoAp20Com (*Communication*) (*$GROUP=User*)
	VAR_INPUT
		nDisplayData : DINT;
		nTargetValue : DINT;
		bc00 : BOOL;
		bc01 : BOOL;
		bc02 : BOOL;
		bc03 : BOOL;
		bc04 : BOOL;
		bc05 : BOOL;
		bc06 : BOOL;
		bc07 : BOOL;
		bc08 : BOOL;
		bc09 : BOOL;
		bc10 : BOOL;
		bc11 : BOOL;
		bc12 : BOOL;
		bc13 : BOOL;
		bc14 : BOOL;
		bc15 : BOOL;
		DC_nStatusWord : UINT;
		DC_nActualValue : DINT;
		DC_nGenMapCh : DINT;
		DC_nErrorStatus : INT;
	END_VAR
	VAR_OUTPUT
		nActualValue : DINT;
		bs00 : BOOL;
		bs01 : BOOL;
		bs02 : BOOL;
		bs03 : BOOL;
		bs04 : BOOL;
		bs05 : BOOL;
		bs06 : BOOL;
		bs07 : BOOL;
		bs08 : BOOL;
		bs09 : BOOL;
		bs10 : BOOL;
		bs11 : BOOL;
		bs12 : BOOL;
		bs13 : BOOL;
		bs14 : BOOL;
		bs15 : BOOL;
		nGenMapCh : DINT;
		nErrorStatus : INT;
		DC_nControlWord : UINT;
		DC_nTargetValue : DINT;
		DC_nDisplayData : DINT;
	END_VAR
END_FUNCTION_BLOCK

FUNCTION_BLOCK FB_SikoAp20CswPos (*Control-/Status word*)
	VAR_INPUT
		bc00_Cal : BOOL;
		bc03_DisplayRange : BOOL;
		bc05_ErrorAck : BOOL;
		bc09_TargetValueActive : BOOL;
		bc11_Led1Green : BOOL;
		bc12_Led1Red : BOOL;
		bc13_Led2Green : BOOL;
		bc14_Led2Red : BOOL;
		bc15_LedBlinking : BOOL;
	END_VAR
	VAR_OUTPUT
		bs00_DirIndicationCW : BOOL;
		bs01_DirIndicationCCW : BOOL;
		bs02_CalExec : BOOL;
		bs03_TarWinExtReached : BOOL;
		bs05_TarWinReached : BOOL;
		bs06_Deviation : BOOL;
		bs07_GeneralError : BOOL;
		bs09_IncMeasurement : BOOL;
		bs10_TargetValueState : BOOL;
		bs11_BatteryState : BOOL;
		bs12_SensorError : BOOL;
		bs13_KeyConfiguration : BOOL;
		bs14_KeyCalibration : BOOL;
		bs15_KeyIncremental : BOOL;
	END_VAR
	VAR_IN_OUT
		DC_Com : FB_SikoAp20Com;
	END_VAR
END_FUNCTION_BLOCK

FUNCTION_BLOCK FB_SikoAp20CswTxt (*Control-/Status word*)
	VAR_INPUT
		bc02_DisplayDataActive : BOOL;
		bc03_DisplayRange : BOOL;
		bc05_ErrorAck : BOOL;
		bc06_TargetValueAckMode : BOOL;
		bc07_TargetValueTypeSelect : BOOL;
		bc08_DisplayDataTypeSelect : BOOL;
		bc09_TargetValueActive : BOOL;
		bc10_DisplayDataAckMode : BOOL;
		bc11_Led1Green : BOOL;
		bc12_Led1Red : BOOL;
		bc13_Led2Green : BOOL;
		bc14_Led2Red : BOOL;
		bc15_LedBlinking : BOOL;
	END_VAR
	VAR_OUTPUT
		bs02_DisplayDataState : BOOL;
		bs03_TargetValueAck : BOOL;
		bs05_DisplayDataAck : BOOL;
		bs07_GeneralError : BOOL;
		bs08_DisplayDataType : BOOL;
		bs09_TargetValueType : BOOL;
		bs10_TargetValueState : BOOL;
		bs11_BatteryState : BOOL;
		bs12_SensorError : BOOL;
		bs13_KeyConfiguration : BOOL;
		bs14_KeyCalibration : BOOL;
		bs15_KeyIncremental : BOOL;
	END_VAR
	VAR_IN_OUT
		DC_Com : FB_SikoAp20Com;
	END_VAR
END_FUNCTION_BLOCK

FUNCTION_BLOCK FB_SikoAp20Prm
	VAR_INPUT
		DC_sDevicename : STRING[80];
		DC_nNodeId : USINT;
		nIndex : UINT;
		bcReadWrite : BOOL;
		nWriteValue : DINT;
		bcExecute : BOOL;
	END_VAR
	VAR_OUTPUT
		bsBusy : BOOL;
		bsError : BOOL;
		bsDone : BOOL;
		nStatus : UINT;
		nErrorInfo : UDINT;
		nReceiveValue : DINT;
	END_VAR
	VAR
		vnSdoReadStep : UINT;
		vnSdoWriteStep : UINT;
		vbOsrExecute : BOOL;
		vbWriteCommand : BOOL;
		vnRxBuffer : DINT;
		vnTxBuffer : DINT;
		fbEplSDORead : EplSDORead;
		vnDataLength : DINT;
		fbEplSDOWrite : EplSDOWrite;
		fbR_TRIG1 : R_TRIG;
	END_VAR
END_FUNCTION_BLOCK
